package com.ruoyi.zdsz.service.impl;

import cn.hutool.core.bean.BeanUtil;
import com.ruoyi.common.annotation.DynamicName;
import com.ruoyi.common.core.domain.BaseEntity;
import com.ruoyi.common.core.domain.entity.SysDictData;
import com.ruoyi.common.helper.LoginHelper;
import com.ruoyi.common.utils.StringUtils;
import com.ruoyi.common.core.page.TableDataInfo;
import com.ruoyi.common.core.domain.PageQuery;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.ruoyi.common.utils.redis.RedisUtils;
import com.ruoyi.framework.handler.MonthTableNameHandler;
import com.ruoyi.system.service.ISysDictTypeService;
import com.ruoyi.zdsz.domain.*;
import com.ruoyi.zdsz.domain.bo.*;
import com.ruoyi.zdsz.domain.vo.*;
import com.ruoyi.zdsz.mapper.*;
import com.ruoyi.zdsz.service.*;
import com.ruoyi.zdsz.task.RiewTask;
import com.ruoyi.zdsz.task.photoTask;
import lombok.RequiredArgsConstructor;
import org.hibernate.validator.internal.util.stereotypes.Lazy;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.scheduling.annotation.Async;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.util.ObjectUtils;

import javax.annotation.Resource;
import java.math.BigDecimal;
import java.text.SimpleDateFormat;
import java.util.*;
import java.util.concurrent.*;
import java.util.logging.Level;
import java.util.stream.Collectors;

/**
 * 民用工程Service业务层处理
 *
 * @author ruoyi
 * @date 2023-12-27
 */
@RequiredArgsConstructor
@Service
public class ZEngineeringCivilServiceImpl implements IZEngineeringCivilService {

    private final ZEngineeringCivilMapper baseMapper;
    @Resource
    private ZAreaMapper zAreaMapper;
    @Resource
    private ZHouseMapper zHouseMapper;

    @Autowired
    private IZEngineeringNodeService izEngineeringNodeService;
    @Resource
    private IZMaterialStatisticsService izMaterialStatisticsService;
    @Resource
    private ZMaterialStatisticsMapper zMaterialStatisticsMapper;
    @Resource
    private ZEngineeringNodeMapper zEngineeringNodeMapper;
    @Resource
    private IZEngineeringReviewService izEngineeringReviewService;
    @Resource
    private IZEngiineeringPhotoService izEngiineeringPhotoService;

    @Override
    public Map<String, List<?>> selectByDistrictStatistics(String district) {
        List<String> name = new ArrayList<>();
        List<Integer> wsg = new ArrayList<>();
        List<Integer> ysg = new ArrayList<>();
        List<Integer> jg = new ArrayList<>();
        for (Map<String, Integer> item : baseMapper.selectByDistrictStatistics(district)) {
            name.add(String.valueOf(item.get("name")));
            wsg.add(item.get("weishigong"));
            ysg.add(item.get("shigongzhong"));
            jg.add(item.get("jungong"));
        }
        Map<String, List<?>> listMap = new HashMap<>();
        listMap.put("name",name);
        listMap.put("wsh",wsg);
        listMap.put("ysg",ysg);
        listMap.put("jg",jg);
        return listMap;
    }

    /**
     * 查询民用工程
     */
    @Override
    public ZEngineeringCivilVo queryById(String id) {
        ZEngineeringCivilVo zEngineeringCivilVo = baseMapper.selectVoById(id);
        ZEngineeringNodeBo zEngineeringNodeBo = new ZEngineeringNodeBo();
        zEngineeringNodeBo.setCreateTime(zEngineeringCivilVo.getCreateTime());
        zEngineeringNodeBo.setCivliId(zEngineeringCivilVo.getId());
        zEngineeringCivilVo.setzEngineeringNodeBoList(izEngineeringNodeService.queryListDetails(zEngineeringNodeBo));
        return zEngineeringCivilVo;
    }

    /**
     * 查询民用工程
     */
    @Override
    public ZEngineeringCivilVo query(String id, String type) {
        ZEngineeringCivilVo zEngineeringCivilVo = baseMapper.selectVoById(id);
        ZEngineeringNodeBo zEngineeringNodeBo = new ZEngineeringNodeBo();
        zEngineeringNodeBo.setCreateTime(zEngineeringCivilVo.getCreateTime());
        zEngineeringNodeBo.setCivliId(zEngineeringCivilVo.getId());
        zEngineeringNodeBo.setType(type);
        zEngineeringCivilVo.setzEngineeringNodeBo(izEngineeringNodeService.query(zEngineeringNodeBo));
        return zEngineeringCivilVo;
    }

    @Override
    public ZEngineeringCivilVo queryProcess(Map<String, String> params) {
        LambdaQueryWrapper<ZEngineeringCivil> lqw = Wrappers.lambdaQuery();
        lqw.eq(StringUtils.isNotBlank(params.get("houseId")), ZEngineeringCivil::getHouseId, params.get("houseId"));
        lqw.eq(StringUtils.isNotBlank(params.get("enginClassification")), ZEngineeringCivil::getEnginClassification, params.get("enginClassification"));
        lqw.eq(StringUtils.isNotBlank(params.get("enginType")), ZEngineeringCivil::getEnginType, params.get("enginType"));
        ZEngineeringCivilVo zEngineeringCivilVo = baseMapper.selectVoOne(lqw);
        ;
        if (!ObjectUtils.isEmpty(zEngineeringCivilVo)) {
            ZEngineeringNodeBo zEngineeringNodeBo = new ZEngineeringNodeBo();
            zEngineeringNodeBo.setCreateTime(zEngineeringCivilVo.getCreateTime());
            zEngineeringNodeBo.setCivliId(zEngineeringCivilVo.getId());
            zEngineeringNodeBo.setType(params.get("type"));
            zEngineeringCivilVo.setzEngineeringNodeBo(izEngineeringNodeService.query(zEngineeringNodeBo));
            return zEngineeringCivilVo;
        }
        return zEngineeringCivilVo;
    }

    @Override
    public ZEngineeringCivilVo queryByEntityBo(ZEngineeringCivilBo zEngineeringCivilBo) {
        LambdaQueryWrapper<ZEngineeringCivil> lqw = Wrappers.lambdaQuery();
        lqw.eq(StringUtils.isNotBlank(zEngineeringCivilBo.getAreaId()), ZEngineeringCivil::getAreaId, zEngineeringCivilBo.getAreaId());
        if (StringUtils.isEmpty(zEngineeringCivilBo.getBuildingId())) {
            lqw.isNull(ZEngineeringCivil::getBuildingId);
        }else {
            lqw.eq(ZEngineeringCivil::getBuildingId, zEngineeringCivilBo.getBuildingId());
        }
        if (StringUtils.isEmpty(zEngineeringCivilBo.getUnitId())) {
            lqw.isNull(ZEngineeringCivil::getUnitId);
        }else{
            lqw.eq(ZEngineeringCivil::getUnitId, zEngineeringCivilBo.getUnitId());
        }
        if (StringUtils.isEmpty(zEngineeringCivilBo.getHouseId())) {
            lqw.isNull(ZEngineeringCivil::getHouseId);
        }else {
            lqw.eq(ZEngineeringCivil::getHouseId, zEngineeringCivilBo.getHouseId());
        }
        lqw.eq(StringUtils.isNotBlank(zEngineeringCivilBo.getEnginCycle()), ZEngineeringCivil::getEnginCycle, zEngineeringCivilBo.getEnginCycle());
        lqw.eq(StringUtils.isNotBlank(zEngineeringCivilBo.getEnginType()), ZEngineeringCivil::getEnginType, zEngineeringCivilBo.getEnginType());
        lqw.eq(StringUtils.isNotBlank(zEngineeringCivilBo.getEnginClassification()), ZEngineeringCivil::getEnginClassification, zEngineeringCivilBo.getEnginClassification());
        ZEngineeringCivilVo selected = baseMapper.selectVoOne(lqw);
        if (!ObjectUtils.isEmpty(selected)){
            selected.setzEngineeringNodeBoList(izEngineeringNodeService.queryNodeList(BeanUtil.copyProperties(selected, ZEngineeringCivil.class)));
        }
        return selected;
    }

    /**
     * 查询民用工程列表
     */
    @Override
    public TableDataInfo<ZEngineeringCivilVo> queryPageList(ZEngineeringCivilBo bo, PageQuery pageQuery) {
        Page<ZBuildingBo> page = new Page<>(pageQuery.getPageNum(), pageQuery.getPageSize());
        LambdaQueryWrapper<ZEngineeringCivil> lqw = Wrappers.lambdaQuery();
        lqw.eq(StringUtils.isNotBlank(bo.getEnginType()), ZEngineeringCivil::getEnginType, bo.getEnginType());
        lqw.eq(StringUtils.isNotBlank(bo.getEnginClassification()), ZEngineeringCivil::getEnginClassification, bo.getEnginClassification());
        lqw.eq(StringUtils.isNotBlank(bo.getEnginCycle()), ZEngineeringCivil::getEnginCycle, bo.getEnginCycle());
        lqw.eq(StringUtils.isNotBlank(bo.getAreaId()), ZEngineeringCivil::getAreaId, bo.getAreaId());
        lqw.eq(StringUtils.isNotBlank(bo.getBuildingId()), ZEngineeringCivil::getBuildingId, bo.getBuildingId());
        lqw.eq(StringUtils.isNotBlank(bo.getUnitId()), ZEngineeringCivil::getUnitId, bo.getUnitId());
        lqw.eq(StringUtils.isNotBlank(bo.getDistrict()), ZEngineeringCivil::getDistrict, bo.getDistrict());
        lqw.eq(StringUtils.isNotBlank(bo.getHouseId()), ZEngineeringCivil::getHouseId, bo.getHouseId());
        Page<ZEngineeringCivilVo> result=new Page<>();
        if (!"".equals(bo.getType())&&!ObjectUtils.isEmpty(bo.getType()))
        {
            List IDList=zEngineeringNodeService.nodeTypeList(baseMapper.selectList(lqw),bo.getType(),bo.getCompletionStatus(),bo);

            if (IDList.size()==0)
            {
                return TableDataInfo.build(result);
            }
            LinkedList <String>list=baseMapper.getTableNames("z_engineering_info");
            List DateList=new ArrayList();
            list.removeLast();
            list.stream().forEach(item->{

                DateList.add(item.substring(item.indexOf("2")));
            });
          result = baseMapper.queryPageIdList(IDList, baseMapper.getTypeNumber(DateList,bo), page,pageQuery.getPageNum() - 1, pageQuery.getPageSize());
            Map<String,Object> ReviewList=zEngineeringNodeService.ReViewList(result.getRecords());
            result.getRecords().forEach(item->{
                    item.setNodeReViewStateList(ReviewList.get(item.getId()));
            });
            page.setTotal(!ObjectUtils.isEmpty(result.getRecords()) ? result.getRecords().get(0).getTotal() : 0);
            return TableDataInfo.build(result);
        }
        if((!"".equals(bo.getBeginTime())&&!ObjectUtils.isEmpty(bo.getBeginTime()))||(!"".equals(bo.getCreateBy())&&!ObjectUtils.isEmpty(bo.getCreateBy())))
        {
            List<String> a= zEngineeringCivilList(bo.getBeginTime(),bo.getCreateBy(),bo);
            if (a.size()==0)
            {
                return TableDataInfo.build(result);
            }
            result = baseMapper.queryPageIdList( a, Long.parseLong(String.valueOf(a.size())), page,pageQuery.getPageNum() - 1, pageQuery.getPageSize());
            Map<String,Object> ReviewList=zEngineeringNodeService.ReViewList(result.getRecords());
            result.getRecords().forEach(item->{
                item.setNodeReViewStateList(ReviewList.get(item.getId()));
            });
            page.setTotal(!ObjectUtils.isEmpty(result.getRecords()) ? result.getRecords().get(0).getTotal() : 0);
            return TableDataInfo.build(result);
        }
        result = baseMapper.queryPageList(bo, page, (pageQuery.getPageNum()-1)*pageQuery.getPageSize() , pageQuery.getPageSize());
        Map<String,Object> ReviewList=zEngineeringNodeService.ReViewList(result.getRecords());
        result.getRecords().forEach(item->{
                item.setNodeReViewStateList(ReviewList.get(item.getId()));
        });
        page.setTotal(!ObjectUtils.isEmpty(result.getRecords()) ? result.getRecords().get(0).getTotal() : 0);
        return TableDataInfo.build(result);
    }

    @Override
    public List<ZEngineeringCivilExportVo> exportList(ZEngineeringCivilBo bo) {
              SimpleDateFormat format=new SimpleDateFormat("yyyy_MM");
              LinkedList <String>list=baseMapper.getTableNames("z_engineering_info");
              list.removeLast();
              List DateList=new ArrayList();
              list.stream().forEach(item->{

                  DateList.add(item.substring(item.indexOf("2")));
              });

              List<ZEngineeringCivilExportVo> zEngineeringCivilExportVoList=baseMapper.getexportList(DateList,format.format(new Date()),bo);
        return zEngineeringCivilExportVoList;
    }

    /**
     * 查询民用工程列表
     */
    @Override
    public List<ZEngineeringCivilVo> queryList(ZEngineeringCivilBo bo) {
        LambdaQueryWrapper<ZEngineeringCivil> lqw = buildQueryWrapper(bo);
        return baseMapper.selectVoList(lqw);
    }

    private LambdaQueryWrapper<ZEngineeringCivil> buildQueryWrapper(ZEngineeringCivilBo bo) {
        LambdaQueryWrapper<ZEngineeringCivil> lqw = Wrappers.lambdaQuery();
        lqw.eq(StringUtils.isNotBlank(bo.getDistrict()), ZEngineeringCivil::getDistrict, bo.getDistrict());
        lqw.eq(StringUtils.isNotBlank(bo.getAreaId()), ZEngineeringCivil::getAreaId, bo.getAreaId());
        lqw.eq(StringUtils.isNotBlank(bo.getBuildingId()), ZEngineeringCivil::getBuildingId, bo.getBuildingId());
        lqw.eq(StringUtils.isNotBlank(bo.getUnitId()), ZEngineeringCivil::getUnitId, bo.getUnitId());
        lqw.eq(StringUtils.isNotBlank(bo.getHouseId()), ZEngineeringCivil::getHouseId, bo.getHouseId());
        lqw.orderByDesc(ZEngineeringCivil::getCreateTime);
        lqw.eq(StringUtils.isNotBlank(bo.getEnginType()), ZEngineeringCivil::getEnginType, bo.getEnginType());
        lqw.eq(StringUtils.isNotBlank(bo.getEnginClassification()), ZEngineeringCivil::getEnginClassification, bo.getEnginClassification());
        lqw.eq(StringUtils.isNotBlank(bo.getEnginCycle()), ZEngineeringCivil::getEnginCycle, bo.getEnginCycle());
        lqw.eq(StringUtils.isNotBlank(bo.getCompletionStatus()), ZEngineeringCivil::getCompletionStatus, bo.getCompletionStatus());
        lqw.eq(StringUtils.isNotBlank(bo.getImgUrl()), ZEngineeringCivil::getImgUrl, bo.getImgUrl());
        return lqw;
    }
    private List<String> zEngineeringCivilList(List createTime, String UserName,ZEngineeringCivilBo bo){
        MonthTableNameHandler.removeData();
        LinkedList <String>list=baseMapper.getTableNames("z_engineering_info");
        list.removeLast();
        List<ZEngineeringInfoBo> mapList= baseMapper.getsumId(list,createTime,UserName);
        List<String> zEngineeringNodeList=new ArrayList<>();
        mapList.stream().forEach(item->{
            String date=  new SimpleDateFormat("yyyy_MM").format(item.getCreateTime());
            MonthTableNameHandler.setData(date);
            LambdaQueryWrapper<ZEngineeringNode> lqw = Wrappers.lambdaQuery();
            lqw.eq(StringUtils.isNotBlank(item.getEngInfoId()),ZEngineeringNode::getId,item.getEngInfoId());
           ZEngineeringNode zEngineeringNode=  zEngineeringNodeMapper.selectOne(lqw);
           if (!ObjectUtils.isEmpty(zEngineeringNode))
            zEngineeringNodeList.add(zEngineeringNode.getCivliId());
            MonthTableNameHandler.removeData();
        });
        List newList = zEngineeringNodeList.stream().distinct().collect(Collectors.toList());
        List CivilList=new ArrayList();
        newList.stream().forEach(item2->{
            LambdaQueryWrapper<ZEngineeringCivil> lqw = Wrappers.lambdaQuery();
            lqw.eq(StringUtils.isNotBlank(bo.getEnginType()), ZEngineeringCivil::getEnginType, bo.getEnginType());
            lqw.eq(StringUtils.isNotBlank(bo.getEnginClassification()), ZEngineeringCivil::getEnginClassification, bo.getEnginClassification());
            lqw.eq(StringUtils.isNotBlank(bo.getEnginCycle()), ZEngineeringCivil::getEnginCycle, bo.getEnginCycle());
            lqw.eq(StringUtils.isNotBlank(bo.getAreaId()), ZEngineeringCivil::getAreaId, bo.getAreaId());
            lqw.eq(StringUtils.isNotBlank(bo.getBuildingId()), ZEngineeringCivil::getBuildingId, bo.getBuildingId());
            lqw.eq(StringUtils.isNotBlank(bo.getUnitId()), ZEngineeringCivil::getUnitId, bo.getUnitId());
            lqw.eq(StringUtils.isNotBlank(bo.getDistrict()), ZEngineeringCivil::getDistrict, bo.getDistrict());
            lqw.eq(ZEngineeringCivil::getId,item2);
            ZEngineeringCivil zEngineeringCivil= baseMapper.selectOne(lqw);
            if (!ObjectUtils.isEmpty(zEngineeringCivil))
            {
                CivilList.add(zEngineeringCivil.getId());
            }
        });
        return CivilList;
    };

    @Autowired
    private ZEngineeringNodeServiceImpl zEngineeringNodeService;

    /**
     * 新增民用工程
     */
    @Override
    @Transactional(rollbackFor = Exception.class)
    public Boolean insertByBo(ZEngineeringCivilBo bo) {
        ZEngineeringCivil add = BeanUtil.toBean(bo, ZEngineeringCivil.class);
        validEntityBeforeSave(add);
        LambdaQueryWrapper<ZEngineeringCivil> lqw = Wrappers.lambdaQuery();
        lqw.eq(StringUtils.isNotBlank(bo.getAreaId()), ZEngineeringCivil::getAreaId, bo.getAreaId());
        if (StringUtils.isEmpty(bo.getBuildingId())) {
            lqw.isNull(ZEngineeringCivil::getBuildingId);
        }else {
            lqw.eq(ZEngineeringCivil::getBuildingId, bo.getBuildingId());
        }
        if (StringUtils.isEmpty(bo.getUnitId())) {
            lqw.isNull(ZEngineeringCivil::getUnitId);
        }else{
            lqw.eq(ZEngineeringCivil::getUnitId, bo.getUnitId());
        }
        if (StringUtils.isEmpty(bo.getHouseId())) {
            lqw.isNull(ZEngineeringCivil::getHouseId);
        }else {
            lqw.eq(ZEngineeringCivil::getHouseId, bo.getHouseId());
        }
        lqw.eq(StringUtils.isNotBlank(bo.getEnginCycle()), ZEngineeringCivil::getEnginCycle, bo.getEnginCycle());
        lqw.eq(StringUtils.isNotBlank(bo.getEnginType()), ZEngineeringCivil::getEnginType, bo.getEnginType());
        lqw.eq(StringUtils.isNotBlank(bo.getEnginClassification()), ZEngineeringCivil::getEnginClassification, bo.getEnginClassification());
        ZEngineeringCivilVo zEngineeringCivilVo = baseMapper.selectVoOne(lqw);
        if ("indoor_engin".equals(bo.getEnginClassification())||"courtyard".equals(bo.getEnginClassification())||"overhead".equals(bo.getEnginClassification())) {
            if (!ObjectUtils.isEmpty(bo.getzEngineeringNodeBo()) || !ObjectUtils.isEmpty(bo.getzEngineeringNodeBoList()) || bo.getzEngineeringNodeBoList().size() > 0)
                izMaterialStatisticsService.insert(bo);
        }
        if (ObjectUtils.isEmpty(zEngineeringCivilVo)) {
            boolean flag = baseMapper.insert(add) > 0;
            if (flag) {
                bo.setId(add.getId());
                if (ObjectUtils.isEmpty(bo.getzEngineeringNodeBo())) {
                    for (ZEngineeringNodeBo zEngineeringNodeBo : bo.getzEngineeringNodeBoList()) {
                        zEngineeringNodeBo.setCivliId(add.getId());
                        zEngineeringNodeBo.setCreateTime(add.getCreateTime());
                        zEngineeringNodeService.insert(zEngineeringNodeBo);
                    }
                    add.setCompletionStatus("施工中");
                    baseMapper.updateById(add);
                } else {
                    ZEngineeringNodeBo zEngineeringNodeBo = bo.getzEngineeringNodeBo();
                    zEngineeringNodeBo.setCivliId(add.getId());
                    zEngineeringNodeBo.setCreateTime(add.getCreateTime());
                    zEngineeringNodeService.insert(zEngineeringNodeBo);
                    add.setCompletionStatus("施工中");
                    baseMapper.updateById(add);
                }
            }
            return flag;
        } else {
            if (!ObjectUtils.isEmpty(bo.getzEngineeringNodeBoList())) {
                for (ZEngineeringNodeBo zEngineeringNodeBo : bo.getzEngineeringNodeBoList()) {
                    zEngineeringNodeBo.setCivliId(zEngineeringCivilVo.getId());
                    zEngineeringNodeBo.setCreateTime(zEngineeringCivilVo.getCreateTime());
                    ZEngineeringNodeBo query = zEngineeringNodeService.query(zEngineeringNodeBo);
                    if (!ObjectUtils.isEmpty(query)) {
                        zEngineeringNodeBo.setId(query.getId());
                    }
                    add.setCompletionStatus("施工中");
                    baseMapper.updateById(add);
                    zEngineeringNodeService.insert(zEngineeringNodeBo);
                }

            } else if (!ObjectUtils.isEmpty(bo.getzEngineeringNodeBo())) {
                ZEngineeringNodeBo zEngineeringNodeBo = bo.getzEngineeringNodeBo();
                zEngineeringNodeBo.setCivliId(zEngineeringCivilVo.getId());
                zEngineeringNodeBo.setType(zEngineeringNodeBo.getType());
                zEngineeringNodeBo.setCreateTime(zEngineeringCivilVo.getCreateTime());
                ZEngineeringNodeBo query = zEngineeringNodeService.query(zEngineeringNodeBo);
                if (!ObjectUtils.isEmpty(query)) {
                    zEngineeringNodeBo.setId(query.getId());
                }
                add.setCompletionStatus("施工中");
                baseMapper.updateById(add);
                zEngineeringNodeService.insert(zEngineeringNodeBo);
            } else {
                throw new RuntimeException("已存在工程,请填写施工信息");
            }
            return true;
        }
    }

    /**
     * 修改民用工程
     */
    @Override
    @Transactional(rollbackFor = Exception.class)
    public Boolean updateByBo(ZEngineeringCivilBo bo) {
        ZEngineeringCivil update = BeanUtil.toBean(bo, ZEngineeringCivil.class);
        validEntityBeforeSave(update);
        boolean flag = baseMapper.updateById(update) > 0;
        if (flag) {
            ZEngineeringCivilVo zEngineeringCivilVo = baseMapper.selectVoById(update.getId());
            ZEngineeringNodeBo zEngineeringNodeBo = bo.getzEngineeringNodeBo();
            if (!ObjectUtils.isEmpty(zEngineeringNodeBo)) {
                zEngineeringNodeBo.setCivliId(zEngineeringCivilVo.getId());
                zEngineeringNodeBo.setCreateTime(zEngineeringCivilVo.getCreateTime());
                if (!ObjectUtils.isEmpty(zEngineeringNodeBo.getzEngineeringInfoBoList()))
                    zEngineeringNodeService.updateMuch(zEngineeringNodeBo);
            }
        }
        return flag;
    }

    /**
     * 保存前的数据校验
     */
    private void validEntityBeforeSave(ZEngineeringCivil entity) {
        //TODO 做一些数据校验,如唯一约束
    }

    /**
     * 批量删除民用工程
     */
    @Override
    public Boolean deleteWithValidByIds(Collection<String> ids, Boolean isValid) {
        if (isValid) {
            //TODO 做一些业务上的校验,判断是否需要校验
            ids.forEach(item -> {
                ZEngineeringCivilVo zEngineeringCivilVo = baseMapper.selectVoById(item);
                ZEngineeringNodeBo zEngineeringNodeBo = new ZEngineeringNodeBo();
                zEngineeringNodeBo.setCreateTime(zEngineeringCivilVo.getCreateTime());
                zEngineeringNodeBo.setCivliId(zEngineeringCivilVo.getId());
                List<ZEngineeringNodeBo> zEngineeringNodeBos = izEngineeringNodeService.queryListDetails(zEngineeringNodeBo);
                zEngineeringNodeBos.forEach(ite -> {
                    LambdaQueryWrapper<ZMaterialStatistics> lqw = Wrappers.lambdaQuery();
                    lqw.eq(StringUtils.isNotBlank(zEngineeringCivilVo.getAreaId()), ZMaterialStatistics::getAreaId, zEngineeringCivilVo.getAreaId());
                    lqw.eq(StringUtils.isNotBlank(zEngineeringCivilVo.getBuildingId()), ZMaterialStatistics::getBuildingId, zEngineeringCivilVo.getBuildingId());
                    lqw.eq(StringUtils.isNotBlank(zEngineeringCivilVo.getUnitId()), ZMaterialStatistics::getUnitId, zEngineeringCivilVo.getUnitId());
                    lqw.eq(StringUtils.isNotBlank(zEngineeringCivilVo.getHouseId()), ZMaterialStatistics::getHouseId, zEngineeringCivilVo.getHouseId());
                    lqw.eq(StringUtils.isNotBlank(zEngineeringCivilVo.getEnginCycle()), ZMaterialStatistics::getEnginCycle, zEngineeringCivilVo.getEnginCycle());
                    lqw.eq(StringUtils.isNotBlank(zEngineeringCivilVo.getEnginClassification()), ZMaterialStatistics::getEnginClassification, zEngineeringCivilVo.getEnginClassification());
                    lqw.eq(StringUtils.isNotBlank(zEngineeringCivilVo.getEnginType()), ZMaterialStatistics::getEnginType, zEngineeringCivilVo.getEnginType());
                    zMaterialStatisticsMapper.delete(lqw);
                    zEngineeringNodeService.delete(ite);
                });
            });
        }
        return baseMapper.deleteBatchIds(ids) > 0;
    }

    @Override
    public int getCivilByAreaId(Collection<String> ids) {
        LambdaQueryWrapper<ZEngineeringCivil> lqw = Wrappers.lambdaQuery();
        lqw.in(!ids.isEmpty(), ZEngineeringCivil::getAreaId, ids);
        return baseMapper.selectVoList(lqw).size();
    }

    @Override
    public int getCivilByhouseId(Collection<String> ids) {
        LambdaQueryWrapper<ZEngineeringCivil> lqw = Wrappers.lambdaQuery();
        lqw.in(!ids.isEmpty(), ZEngineeringCivil::getHouseId, ids);
        return baseMapper.selectVoList(lqw).size();
    }

    @Override
    public List getObtainRoomcCompletionInformationList(ZEngineeringCivilBo bo) {
        List<roomStatusVo> roomStatusList = baseMapper.getObtainRoomcCompletionInformationList(bo);
        Map<String, List<roomStatusVo>> map = new HashMap<>();
        map = roomStatusList.stream().collect(Collectors.groupingBy(item -> item.getUnitName()));
        List areaList = new ArrayList();
        map.forEach((key, value) -> {
            BulidingStatusVo bulidingStatusVo = new BulidingStatusVo();
            bulidingStatusVo.setUnitName(key);
            bulidingStatusVo.setUnitId(value.get(0).getUnitId());
            //bulidingStatusVo.setRoomStatusVoList(value);
            Map<String, List<roomStatusVo>> roomMap = value.stream().collect(Collectors.groupingBy(item -> (
                item.getRoomName().replaceAll("[^0-9]","").length() > 3 ? item.getRoomName().substring(0,2):item.getRoomName().substring(0,1))
                ));
            List willDone = value.stream().filter(item -> item.getRoomStatus().equals("未施工")).collect(Collectors.toList());
            List notstart = value.stream().filter(item -> item.getRoomStatus().equals("施工中")).collect(Collectors.toList());
            List done = value.stream().filter(item -> item.getRoomStatus().equals("竣工")).collect(Collectors.toList());
            List<List<roomStatusVo>> roomStatusVoList = new ArrayList<>();
            Map<String, List<roomStatusVo>> sortMap = roomMap.entrySet().stream().sorted(Comparator.comparingInt(entry -> Integer.parseInt(entry.getKey()))).collect(Collectors.toMap(Map.Entry::getKey, Map.Entry::getValue, (oldVal, newVal) -> oldVal, LinkedHashMap::new));
            sortMap.forEach((key1, value1) -> {
                roomStatusVoList.add(value1);
            });
            bulidingStatusVo.setRoomStatusVoList(roomStatusVoList);
            bulidingStatusVo.setDone(String.valueOf(done.size()));
            bulidingStatusVo.setWillDone(String.valueOf(willDone.size()));
            bulidingStatusVo.setNotstart(String.valueOf(notstart.size()));
            areaList.add(bulidingStatusVo);
        });
        return areaList;
    }

    @Override
    public TableDataInfo<areaStatusVo> getAreaCompletionInformationList(ZEngineeringCivilBo bo, PageQuery po) {
        LambdaQueryWrapper<ZArea> lqw = Wrappers.lambdaQuery();
        lqw.eq(StringUtils.isNotBlank(bo.getAreaId()), ZArea::getId, bo.getAreaId());
        lqw.eq(StringUtils.isNotBlank(bo.getDistrict()), ZArea::getDistrict, bo.getDistrict());
        Page<ZBuildingBo> page = new Page<>(po.getPageNum(), po.getPageSize());
        Page<ZAreaVo> result = zAreaMapper.selectVoPage(po.build(), lqw);
        List<ZAreaVo> IdList = result.getRecords();
        List Id = new ArrayList();
        IdList.stream().forEach(item -> {
            Id.add(item.getId());
        });
        List<areaWillDoneVo> hourseList = baseMapper.getAreaCompletionInformationList(Id, bo.getEnginCycle());
        Map<String, List<areaWillDoneVo>> stringListMap = hourseList.stream().collect(Collectors.groupingBy(item -> item.getAreaId()));
        List<areaStatusVo> areaList = new ArrayList<>();
        stringListMap.forEach((key, value) -> {
            areaStatusVo areaStatusVo = new areaStatusVo();
            List  notstart = value.stream().filter(item -> item.getRoomStatus().equals("未施工")).collect(Collectors.toList());
            List  willDone = value.stream().filter(item -> item.getRoomStatus().equals("施工中")).collect(Collectors.toList());
            List done = value.stream().filter(item -> item.getRoomStatus().equals("竣工")).collect(Collectors.toList());
            areaStatusVo.setAreaId(key);
            areaStatusVo.setAreaName(value.get(0).getName());
            areaStatusVo.setWillDone(String.valueOf(willDone.size()));
            areaStatusVo.setNotstart(String.valueOf(notstart.size()));
            areaStatusVo.setDone(String.valueOf(done.size()));
            areaStatusVo.setScale(value.get(0).getScale().toString());
            areaList.add(areaStatusVo);
        });
        Page<areaStatusVo> page2 = new Page<>();
        BeanUtils.copyProperties(result, page2);
        page2.setRecords(areaList);
        return TableDataInfo.build(page2);
    }

    @Override
    public List<areaStatusVo> getAreaCompletionInformationList2(ZEngineeringCivilBo bo) {
        List<areaWillDoneVo> hourseList = baseMapper.getAreaCompletionInformationList2( bo.getEnginCycle());
        Map<String, List<areaWillDoneVo>> stringListMap = hourseList.stream().collect(Collectors.groupingBy(item -> item.getAreaId()));
        List<areaStatusVo> areaList = new ArrayList<>();
        stringListMap.forEach((key, value) -> {
            areaStatusVo areaStatusVo = new areaStatusVo();
            List  notstart = value.stream().filter(item -> item.getRoomStatus().equals("未施工")).collect(Collectors.toList());
            List  willDone = value.stream().filter(item -> item.getRoomStatus().equals("施工中")).collect(Collectors.toList());
            List done = value.stream().filter(item -> item.getRoomStatus().equals("竣工")).collect(Collectors.toList());
            areaStatusVo.setAreaId(key);
            areaStatusVo.setAreaName(value.get(0).getName());
            areaStatusVo.setWillDone(String.valueOf(willDone.size()));
            areaStatusVo.setNotstart(String.valueOf(notstart.size()));
            areaStatusVo.setDone(String.valueOf(done.size()));
            areaStatusVo.setScale(value.get(0).getScale().toString());
            areaList.add(areaStatusVo);
        });

        return areaList;
    }

    @Override
    public Map<String,Number> getsumStatus(ZEngineeringCivilBo bo) {
        Map<String,Number> areaStatusVo = baseMapper.getsumStatus(bo.getDistrict());
//        areaStatusVo.setNotstart(String.valueOf(Integer.parseInt(areaStatusVo.getNotstart()) - Integer.parseInt(areaStatusVo.getWillDone()) - Integer.parseInt(areaStatusVo.getDone())));
        return areaStatusVo;
    }

    @Override
    public int batchReview(ZEngineeringCivilBo bo, ZEngineeringNodeBo zEngineeringNodeBo) {
        ZEngineeringCivil add = BeanUtil.toBean(bo, ZEngineeringCivil.class);
        validEntityBeforeSave(add);
        LambdaQueryWrapper<ZEngineeringCivil> lqw = Wrappers.lambdaQuery();
        //        lqw.eq(StringUtils.isNotBlank(bo.getAreaId()), ZEngineeringCivil::getAreaId, bo.getAreaId());
        //        lqw.eq(ZEngineeringCivil::getBuildingId, bo.getBuildingId());
        //        lqw.eq(ZEngineeringCivil::getUnitId, bo.getUnitId());
        //        lqw.eq(ZEngineeringCivil::getHouseId, bo.getHouseId());
        lqw.eq(StringUtils.isNotBlank(bo.getEnginCycle()), ZEngineeringCivil::getEnginCycle, bo.getEnginCycle());
        lqw.eq(StringUtils.isNotBlank(bo.getEnginClassification()), ZEngineeringCivil::getEnginClassification, bo.getEnginClassification());
        lqw.eq(StringUtils.isNotBlank(bo.getEnginType()), ZEngineeringCivil::getEnginType, bo.getEnginType());
        //        SimpleDateFormat dateFormat = new SimpleDateFormat("yyyy-MM");
        lqw.like(StringUtils.isNotBlank(bo.getReviewTime().toString()), ZEngineeringCivil::getCreateTime, bo.getReviewTime());
        Long sumcount = baseMapper.selectCount(lqw);
        //        List<ZEngineeringCivil> zEngineeringCivilList=baseMapper.selectList(lqw);
        /**
         * 线程执行插入量
         */
        int count = 500;
        //        List<ZEngineeringCivil> newList = new ArrayList();
        if (sumcount > 0) {
            //线程数量（根据查询总数量进行分配线程数量）
            int runSize = (int) (sumcount / count + 1);
            //ThreadPoolExecutor threadPoolTaskExecutor = new ScheduledThreadPoolExecutor(runSize);
            ExecutorService threadPoolTaskExecutor = Executors.newCachedThreadPool();
            CountDownLatch countDownLatch = new CountDownLatch(runSize);
            for (int i = 1; i <= runSize; i++) {
                Page page = new Page<>(i, count);
                //                Page<ZEngineeringCivil> zEngineeringCivilPage = baseMapper.selectPage(page, lqw);
                //                if((i+1)==runSize){
                //                    int startIndex = (i*count);;
                //                    int endIndex = zEngineeringCivilList.size();
                //                    newList =zEngineeringCivilList.subList(startIndex,endIndex);
                //                }else{
                //                    int startIndex = i*count;;
                //                    int endIndex = (i+1)*count;
                //                    newList =zEngineeringCivilList.subList(startIndex,endIndex);
                //                }
                System.out.println("第" + i + "次查询：" + page.getSize());
                threadPoolTaskExecutor.execute(new RiewTask(zEngineeringNodeBo, countDownLatch, page, lqw));
                threadPoolTaskExecutor.execute(new photoTask(zEngineeringNodeBo, countDownLatch, page, lqw));
            }
            threadPoolTaskExecutor.shutdown();
            //            try {
            //                countDownLatch.await();
            //                threadPoolTaskExecutor.shutdown();
            //            } catch (InterruptedException e) {
            //                throw new RuntimeException(e);
            //            }
            //
        }

        return 0;
    }

    @Override
    @DynamicName(spel = "#zEngineeringReviewBo.createTime")
    public int Civilinsert(ZEngineeringReviewBo zEngineeringReviewBo) {
        ZEngineeringNode zEngineeringNode = zEngineeringNodeMapper.selectById(zEngineeringReviewBo.getEngInfoId());
        ZEngineeringCivil zEngineeringCivil = baseMapper.selectById(zEngineeringNode.getCivliId());
        ZEngineeringCivilBo zEngineeringCivilBo = BeanUtil.copyProperties(zEngineeringCivil, ZEngineeringCivilBo.class);
        ZEngineeringNodeBo zEngineeringNodeBo = BeanUtil.copyProperties(zEngineeringNode, ZEngineeringNodeBo.class);
        zEngineeringCivilBo.setzEngineeringNodeBo(izEngineeringNodeService.query(zEngineeringNodeBo));
        zEngineeringCivilBo.setCreateTime(zEngineeringReviewBo.getCreateTime());
        izEngineeringReviewService.Civilinsert(zEngineeringCivil, zEngineeringReviewBo);
        areaMessageVo areaMessageVo=new areaMessageVo();
        if (zEngineeringCivilBo.getEnginClassification().equals("courtyard")||zEngineeringCivilBo.getEnginClassification().equals("overhead "))
        {
            if (!"".equals(zEngineeringCivilBo.getBuildingId()))
            {
                areaMessageVo = baseMapper.getAreaMessage(zEngineeringCivilBo.getBuildingId());
                areaMessageVo.setHouseId("未知");
                areaMessageVo.setUnitId("未知");
            }else
            {
                areaMessageVo = baseMapper.getAreaName(zEngineeringCivilBo.getAreaId());
                areaMessageVo.setHouseId("未知");
                areaMessageVo.setUnitId("未知");
                areaMessageVo.setBuildingId("未知");
            }
        }else{
            areaMessageVo = baseMapper.getHouseMessage(zEngineeringCivilBo.getHouseId());
        }
//        areaMessageVo areaMessageVo = baseMapper.getHouseMessage(zEngineeringCivilBo.getHouseId());
        if (!ObjectUtils.isEmpty(areaMessageVo))

        BeanUtils.copyProperties(areaMessageVo, zEngineeringCivilBo);
        Map<String, List<SysDictData>> sysDictMap = RedisUtils.getCacheMap("sys_dict");
        sysDictMap.get(zEngineeringCivilBo.getEnginType()).stream().forEach(item -> {
            if (item.getDictValue().equals(zEngineeringCivilBo.getEnginClassification())) {
                zEngineeringCivilBo.setEnginClassification(item.getDictLabel());
            }
        });
//        sysDictMap.get(zEngineeringCivilBo.getEnginType() + "_" + zEngineeringCivilBo.getEnginClassification()).stream().forEach(item -> {
//            if (item.getDictValue().equals(zEngineeringCivilBo.getzEngineeringNodeBo().getType())) {
//                zEngineeringCivilBo.setEnginClassification(item.getDictLabel());
//            }
//        });
        sysDictMap.get("engin_cycle").stream().forEach(item -> {
            if (item.getDictValue().equals(zEngineeringCivilBo.getEnginCycle())) {
                zEngineeringCivilBo.setEnginCycle(item.getDictLabel());
            }
        });
        //        zEngineeringCivilBo.getzEngineeringNodeBo().setType(type);
        //        zEngineeringCivilBo.setEnginClassification(completionStatus);
        if (zEngineeringCivilBo.getEnginType().equals("old_renovation")) {
            zEngineeringCivilBo.setEnginType("旧改");
        } else if (zEngineeringCivilBo.getEnginType().equals("new_built")) {
            zEngineeringCivilBo.setEnginType("新建");
        }

        izEngiineeringPhotoService.write(zEngineeringCivilBo);
        return 0;
    }

    @Override
    public List<ZEngineeringNodeBo> getRivewStatus(String Id) {
        ZEngineeringCivil zEngineeringCivil1= baseMapper.selectById(Id);
        if(!ObjectUtils.isEmpty(zEngineeringCivil1))
        {

            return izEngineeringNodeService.queryNodeList(zEngineeringCivil1);
        }else
        {
            return null;
        }

    }

    @Override
    public Boolean batchNode(ZEngineeringCivilBo bo) {
     List<ZHouse> zHouseList=zHouseMapper.selectHouseId(bo);
         zEngineeringNodeService.batchNode(zHouseList,bo,LoginHelper.getLoginUser().getUserId().toString());
        return true ;

    }
}


